<?php

namespace Drupal\moderation_team\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Url;

/**
 * Controller for queue list.
 */
class ModerationTeamController extends ControllerBase {

  /**
   * Queue lists
   */
  public function queues(){

    $database = \Drupal::database();

    $query = $database->select('mt_queue', 'mq');
    $query->join('node_field_data', 'n', 'n.nid = mq.nid');
    $query->addField('mq', 'queue_id');
    $query->addExpression('COUNT(mq.queue_id)', 'cnt');
    $query->addExpression('MAX(mq.queue_id)', 'qid');
    $query->condition('is_answerable', 0, '=');
    $query->groupBy('mq.queue_id');
    $data = $query->execute();
    $results = $data->fetchAll();

    $queues = [];

    foreach($results as $key => $result) {
      $link = '';
      $url = Url::fromRoute('view.moderation_node_list.page_1', ['queue_id' => $result->qid]);

      if (!empty($url)) {
        $link = $url->toString();
      }

      $queues[$key]['id'] = $result->qid;
      $queues[$key]['cnt'] = $result->cnt;
      $queues[$key]['link'] = $link;
    }

    return array(
      '#theme' => 'queues',
      '#queues' => $queues,
    );
  }
}